///home/berryj/link/bin/genMethods "-g" "-t" "Sequence<int>" "-h" "List" "-I" "LINK/basic/Sequence.h" "-I" "LINK/basic/List.h" "-d" "basic" 
#include <stk.h>
#include <LINK/stkWrapper/LINK_STk.h>

#include <LINK/basic/Sequence.h>

#include <LINK/basic/List.h>

#include <LINK/stkWrapper/Wrapper.h>
#include <LINK/stkWrapper/Register.h>
#include <LINK/stkWrapper/ListWrapper.h>


typedef Sequence<int> _Sequence_int_;
typedef List<Sequence<int> > _List_Sequence_int__;
static List<Sequence<int> > s__List_Sequence_int__;

#define _List_Sequence_int__DATA(x) ((List<Sequence<int> >*) (EXTDATA(x)))
#define _List_Sequence_int__IS_DATA(x) (TYPEP(x, tc_CXXwrapper) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Sequence<int> > >::type))
#define _List_Sequence_int__ISNT_DATA(x) (!_List_Sequence_int__IS_DATA(x))

#define _List_Sequence_int__CXX_DATA(x) (*(List<Sequence<int> >*) (EXTDATA(VAL(x))))
#define _List_Sequence_int__CXX_IS_DATA(x) (INSTANCEP(x) && \
		TYPEP(STk_slot_ref(x,val_scm), tc_CXXwrapper) && \
		(EXTID(STk_slot_ref(x,val_scm)) == Wrapper<List<Sequence<int> > >::type))
#define _List_Sequence_int__CXX_ISNT_DATA(x) (!_List_Sequence_int__CXX_IS_DATA(x))


PRIMITIVE STk_init__List_Sequence_int__()
{
	Wrapper<_List_Sequence_int__>::type = STk_new_CXXwrapper_id(
			Wrapper<_List_Sequence_int__>::name, 
			"",
			(void (*)(SCM x, SCM port, int mode))
			ListWrapper<_Sequence_int_>::displayTypedList,
			(void (*)(SCM x))ListWrapper<_Sequence_int_>::markTypedList,
			(void (*)(SCM x))ListWrapper<_Sequence_int_>::freeTypedList);
	Tcl_InitHashTable(&Register<_List_Sequence_int__>::objTable, TCL_ONE_WORD_KEYS);
	return UNDEFINED;
}

void genExtra_List_Sequence_int__Methods(void);

PRIMITIVE STk_init_methods__List_Sequence_int__()
{
	STk_add_new_cpp_primitive("List-Sequence-int-make", tc_subr_0, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_int_>::makeLinkList);
	STk_add_new_cpp_primitive("List-Sequence-int?", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_int_>::linkListP);
	STk_add_new_cpp_primitive("list->List-Sequence-int", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_int_>::stkList2LinkList);
	STk_add_new_cpp_primitive("List-Sequence-int->list", tc_subr_1, 
	(PRIMITIVE (*)(...))  ListWrapper<_Sequence_int_>::linkList2STkList);
	genExtra_List_Sequence_int__Methods();
	return UNDEFINED;
}
